<!DOCTYPE html>
<html>
<head>
    <title>WebSocket Client Test</title>
</head>
<body>
    <h1>WebSocket Client Test</h1>
    <div>
        <button onclick="connectWebSocket()">Connect</button>
        <button onclick="sendMessage()">Send Message</button>
        <button onclick="closeWebSocket()">Close</button>
    </div>
    <div>
        <label for="message">Message:</label>
        <input type="text" id="message">
    </div>
    <div>
        <h2>Received Messages:</h2>
        <ul id="receivedMessages"></ul>
    </div>

    <script>
        let webSocket;

        function connectWebSocket() {
            // Establish a WebSocket connection
            webSocket = new WebSocket('ws://localhost:3000');

            // WebSocket event handlers
            webSocket.onopen = (event) => {
                console.log('WebSocket connected');
            };

            webSocket.onmessage = (event) => {
                console.log('Received:', event.data);
                const receivedMessages = document.getElementById('receivedMessages');
                const li = document.createElement('li');
                li.textContent = event.data;
                receivedMessages.appendChild(li);
            };

            webSocket.onclose = (event) => {
                console.log('WebSocket closed');
            };

            webSocket.onerror = (event) => {
                console.error('WebSocket error:', event);
            };
        }

        function sendMessage() {
            const messageInput = document.getElementById('message');
            const message = messageInput.value;
            if (webSocket && webSocket.readyState === WebSocket.OPEN) {
                webSocket.send(message);
                messageInput.value = '';
            }
        }

        function closeWebSocket() {
            if (webSocket) {
                webSocket.close();
            }
        }
    </script>
</body>
</html>
